/*
 * keyboard.h
 *
 *  Created on: 24.03.2018
 *      Author: Rafa
 */

/*
 * https://docs.mbed.com/docs/ble-hid/en/latest/api/md_doc_HID.html
 * http://www.usb.org/developers/hidpage/Hut1_12v2.pdf
 */

#ifndef KEYBOARD_H_
#define KEYBOARD_H_

struct keys {
	uint8_t modifiers;
	uint8_t key;
};

void send_sequence(struct keys *d);

#define LEFT_CTRL		0x01
#define LEFT_SHIFT		0x02
#define LEFT_ALT		0x04
#define LEFT_GUI		0x08
#define RIGHT_CTRL		0x10
#define RIGHT_SHIFT		0x20
#define RIGHT_ALT		0x40
#define RIGHT_GUI		0x80

#define KEY_A			0x04
#define KEY_B			0x05
#define KEY_C			0x06
#define KEY_D			0x07
#define KEY_E			0x08
#define KEY_F			0x09
#define KEY_G			0x0A
#define KEY_H			0x0B
#define KEY_I			0x0C
#define KEY_J			0x0D
#define KEY_K			0x0E
#define KEY_L			0x0F
#define KEY_M			0x10
#define KEY_N			0x11
#define KEY_O			0x12
#define KEY_P			0x13
#define KEY_Q			0x14
#define KEY_R			0x15
#define KEY_S			0x16
#define KEY_T			0x17
#define KEY_U			0x18
#define KEY_V			0x19
#define KEY_W			0x1A
#define KEY_X			0x1B
#define KEY_Y			0x1C
#define KEY_Z			0x1D

#define KEY_1			0x1E
#define KEY_2			0x1F
#define KEY_3			0x20
#define KEY_4			0x21
#define KEY_5			0x22
#define KEY_6			0x23
#define KEY_7			0x24
#define KEY_8			0x25
#define KEY_9			0x26
#define KEY_0			0x27

#define KEY_ENTER		0x28
#define KEY_ESC			0x29
#define KEY_DELETE		0x2A
#define KEY_TAB			0x2B
#define KEY_SPACE		0x2C

#define KEY_MINUS		0x2D
#define KEY_EQUAL		0x2E
#define KEY_BRACKET_L	0x2F
#define KEY_BRACKET_R	0x30
#define KEY_BACKSLASH	0x31
#define KEY_STH_0		0x32
#define KEY_SEMICOLON	0x33
#define KEY_QUOTATION	0x34
#define KEY_GRAVE_ACCENT	0x35
#define KEY_COMMA		0x36
#define KEY_DOT			0x37
#define KEY_SLASH		0x38
#define	KEY_CAPSLOCK	0x39

#define KEY_F1			0x3A

#endif /* KEYBOARD_H_ */
